/*
*	Under construction
*/

#include <u.h>
#include <libc.h>
#include <bio.h>
#include "misc.h"

#define DBG if(0)

Biobuf bout;
char *sep;


void
usage(void)
{
	fprint(2,"usage: kmerge file1 file2 \n");
	exits("usage");
}


#define BUFSIZE 32*1024

int
cmp(char *p1, char *p2)
{
	return strcmp(p1,p2);
}

void
merge(int fd1, int fd2)
{
	char *p,*p1,*p2;
	Rdbuf *rb1, *rb2;
	int m;
	rb1 = RdbufNew(fd1, 32*1024);
	rb2 = RdbufNew(fd2, 32*1024);

	p1 = rdline(rb1);
	p2 = rdline(rb2);
	while(p1 && p2){
		m = cmp(p1,p2);
		p = (m<0)?p1:p2;
		Bprint(&bout,"%s\n",p);
		if(m <= 0)
			p1 = rdline(rb1);
		if(m >= 0)
			p2 = rdline(rb2);
	}
	if(p1)
		while(p1){
			Bprint(&bout,"%s\n",p1);
			p1 = rdline(rb1);
		}
	if(p2)
		while(p2){
			Bprint(&bout,"%s\n",p2);
			p2 = rdline(rb2);
		}
}

void
main(int argc, char *argv[])
{
	int fd1,fd2;
	ARGBEGIN{
	case 'F':	sep=EARGF(usage()); /* currently unused */
		break;
	default: usage();
	}ARGEND

	if(argc != 2)
		usage();

	Binit(&bout, 1, OWRITE);

	fd1 = open(argv[0], OREAD);
	if(fd1 < 0)
		sysfatal("%s not open",argv[0]);
	fd2 = open(argv[1], OREAD);
	if(fd2 < 0)
		sysfatal("%s not open",argv[1]);
	merge(fd1,fd2);
	close(fd1);
	close(fd2);
	exits(nil);
}

